1 # SPDX-License-Identifier: GPL-2.0+
10 # To see a list of typical targets execute "make help"
11 # More info can be located in ./README
12 # Comments in this file are targeted only to the developer, do not
13 # expect to learn how to build the kernel reading this file.
15 # Do not use make's built-in rules and variables
16 # (this increases performance and avoids hard-to-debug behaviour)
19 # Determine target architecture for the sandbox
20 include include/host_arch.h
21 ifeq ("", "$(CROSS_COMPILE)")
22 MK_ARCH="${shell uname -m}"
24 MK_ARCH="${shell echo $(CROSS_COMPILE) | sed -n 's/^[[:space:]]*\([^\/]*\/\)*\([^-]*\)-[^[:space:]]*/\2/p'}"
27 ifeq ("x86_64", $(MK_ARCH))
28 export HOST_ARCH=$(HOST_ARCH_X86_64)
29 else ifneq (,$(findstring $(MK_ARCH), "i386" "i486" "i586" "i686"))
30 export HOST_ARCH=$(HOST_ARCH_X86)
31 else ifneq (,$(findstring $(MK_ARCH), "aarch64" "armv8l"))
32 export HOST_ARCH=$(HOST_ARCH_AARCH64)
33 else ifneq (,$(findstring $(MK_ARCH), "arm" "armv7" "armv7a" "armv7l"))
34 export HOST_ARCH=$(HOST_ARCH_ARM)
35 else ifeq ("riscv32", $(MK_ARCH))
36 export HOST_ARCH=$(HOST_ARCH_RISCV32)
37 else ifeq ("riscv64", $(MK_ARCH))
38 export HOST_ARCH=$(HOST_ARCH_RISCV64)
42 # Avoid funny character set dependencies
46 export LC_COLLATE LC_NUMERIC
48 # Avoid interference with shell env settings
51 # We are using a recursive build, so we need to do a little thinking
52 # to get the ordering right.
54 # Most importantly: sub-Makefiles should only ever modify files in
55 # their own directory. If in some directory we have a dependency on
56 # a file in another dir (which doesn't happen often, but it's often
57 # unavoidable when linking the built-in.o targets which finally
58 # turn into vmlinux), we will call a sub make in that other dir, and
59 # after that we are sure that everything which is in that other dir
62 # The only cases where we need to modify files which have global
63 # effects are thus separated out and done before the recursive
64 # descending is started. They are now explicitly listed as the
68 # ---------------------------------------------------------------------------
70 # Normally, we echo the whole command before executing it. By making
71 # that echo $($(quiet)$(cmd)), we now have the possibility to set
72 # $(quiet) to choose other forms of output instead, e.g.
74 # quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
75 # cmd_cc_o_c = $(CC) $(c_flags) -c -o $@ $<
77 # If $(quiet) is empty, the whole command will be printed.
78 # If it is set to "quiet_", only the short version will be printed.
79 # If it is set to "silent_", nothing will be printed at all, since
80 # the variable $(silent_cmd_cc_o_c) doesn't exist.
82 # A simple variant is to prefix commands with $(Q) - that's useful
83 # for commands that shall be hidden in non-verbose mode.
87 # If KBUILD_VERBOSE equals 0 then the above command will be hidden.
88 # If KBUILD_VERBOSE equals 1 then the above command is displayed.
90 # To put more focus on warnings, be less verbose as default
91 # Use 'make V=1' to see the full commands
93 ifeq ("$(origin V)", "command line")
100 ifeq ($(KBUILD_VERBOSE),1)
108 # If the user is running make -s (silent mode), suppress echoing of
111 ifneq ($(filter 4.%,$(MAKE_VERSION)),) # make-4
112 ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
116 ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
121 export quiet Q KBUILD_VERBOSE
123 # kbuild supports saving output files in a separate directory.
124 # To locate output files in a separate directory two syntaxes are supported.
125 # In both cases the working directory must be the root of the kernel src.
127 # Use "make O=dir/to/store/output/files/"
129 # 2) Set KBUILD_OUTPUT
130 # Set the environment variable KBUILD_OUTPUT to point to the directory
131 # where the output files shall be placed.
132 # export KBUILD_OUTPUT=dir/to/store/output/files/
135 # The O= assignment takes precedence over the KBUILD_OUTPUT environment
138 # KBUILD_SRC is set on invocation of make in OBJ directory
139 # KBUILD_SRC is not intended to be used by the regular user (for now)
140 ifeq ($(KBUILD_SRC),)
142 # OK, Make called in directory where kernel src resides
143 # Do we want to locate output files in a separate directory?
144 ifeq ("$(origin O)", "command line")
145 KBUILD_OUTPUT := $(O)
148 # That's our default target when none is given on the command line
152 # Cancel implicit rules on top Makefile
153 $(CURDIR)/Makefile Makefile: ;
155 ifneq ($(KBUILD_OUTPUT),)
156 # Invoke a second make in the output directory, passing relevant variables
157 # check that the output directory actually exists
158 saved-output := $(KBUILD_OUTPUT)
159 KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
161 $(if $(KBUILD_OUTPUT),, \
162 $(error failed to create output directory "$(saved-output)"))
164 # Look for make include files relative to root of kernel src
166 # This does not become effective immediately because MAKEFLAGS is re-parsed
167 # once after the Makefile is read. It is OK since we are going to invoke
169 MAKEFLAGS += --include-dir=$(CURDIR)
171 PHONY += $(MAKECMDGOALS) sub-make
173 $(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
177 $(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
178 -f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
180 # Leave processing to above invocation of make
182 endif # ifneq ($(KBUILD_OUTPUT),)
183 endif # ifeq ($(KBUILD_SRC),)
185 # We process the rest of the Makefile if this is the final invocation of make
186 ifeq ($(skip-makefile),)
188 # Do not print "Entering directory ...",
189 # but we want to display it when entering to the output directory
190 # so that IDEs/editors are able to understand relative filenames.
191 MAKEFLAGS += --no-print-directory
193 # Call a source code checker (by default, "sparse") as part of the
196 # Use 'make C=1' to enable checking of only re-compiled files.
197 # Use 'make C=2' to enable checking of *all* source files, regardless
198 # of whether they are re-compiled or not.
200 # See the file "doc/sparse.txt" for more details, including
201 # where to get the "sparse" utility.
203 ifeq ("$(origin C)", "command line")
204 KBUILD_CHECKSRC = $(C)
206 ifndef KBUILD_CHECKSRC
210 # Use make M=dir to specify directory of external module to build
211 # Old syntax make ... SUBDIRS=$PWD is still supported
212 # Setting the environment variable KBUILD_EXTMOD take precedence
214 KBUILD_EXTMOD ?= $(SUBDIRS)
217 ifeq ("$(origin M)", "command line")
218 KBUILD_EXTMOD := $(M)
221 # If building an external module we do not care about the all: rule
222 # but instead _all depend on modules
224 ifeq ($(KBUILD_EXTMOD),)
230 ifeq ($(KBUILD_SRC),)
231 # building in the source tree
234 ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
235 # building in a subdirectory of the source tree
238 srctree := $(KBUILD_SRC)
245 VPATH := $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))
247 export srctree objtree VPATH
249 # Make sure CDPATH settings don't interfere
252 #########################################################################
254 HOSTARCH := $(shell uname -m | \
256 -e s/sun4u/sparc64/ \
259 -e s/ppc64/powerpc/ \
261 -e s/macppc/powerpc/\
264 HOSTOS := $(shell uname -s | tr '[:upper:]' '[:lower:]' | \
265 sed -e 's/\(cygwin\).*/cygwin/')
267 export HOSTARCH HOSTOS
269 #########################################################################
271 # set default to nothing for native builds
272 ifeq ($(HOSTARCH),$(ARCH))
276 KCONFIG_CONFIG ?= .config
277 export KCONFIG_CONFIG
279 # SHELL used by kbuild
280 CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
281 else if [ -x /bin/bash ]; then echo /bin/bash; \
282 else echo sh; fi ; fi)
284 HOST_LFS_CFLAGS := $(shell getconf LFS_CFLAGS 2>/dev/null)
285 HOST_LFS_LDFLAGS := $(shell getconf LFS_LDFLAGS 2>/dev/null)
286 HOST_LFS_LIBS := $(shell getconf LFS_LIBS 2>/dev/null)
290 KBUILD_HOSTCFLAGS := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
291 $(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
292 KBUILD_HOSTCXXFLAGS := -O2 $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
293 KBUILD_HOSTLDFLAGS := $(HOST_LFS_LDFLAGS) $(HOSTLDFLAGS)
294 KBUILD_HOSTLDLIBS := $(HOST_LFS_LIBS) $(HOSTLDLIBS)
296 # With the move to GCC 6, we have implicitly upgraded our language
297 # standard to GNU11 (see https://gcc.gnu.org/gcc-5/porting_to.html).
298 # Some Linux distributions (including RHEL7, SLES13, Debian 8) still
299 # have older compilers as their default, so we make it explicit for
300 # these that our host tools are GNU11 (i.e. C11 w/ GNU extensions).
301 CSTD_FLAG := -std=gnu11
302 KBUILD_HOSTCFLAGS += $(CSTD_FLAG)
304 ifeq ($(HOSTOS),cygwin)
305 KBUILD_HOSTCFLAGS += -ansi
308 # Mac OS X / Darwin's C preprocessor is Apple specific. It
309 # generates numerous errors and warnings. We want to bypass it
310 # and use GNU C's cpp. To do this we pass the -traditional-cpp
311 # option to the compiler. Note that the -traditional-cpp flag
312 # DOES NOT have the same semantics as GNU C's flag, all it does
313 # is invoke the GNU preprocessor in stock ANSI/ISO C fashion.
315 # Apple's linker is similar, thanks to the new 2 stage linking
316 # multiple symbol definitions are treated as errors, hence the
317 # -multiply_defined suppress option to turn off this error.
319 ifeq ($(HOSTOS),darwin)
320 # get major and minor product version (e.g. '10' and '6' for Snow Leopard)
321 DARWIN_MAJOR_VERSION = $(shell sw_vers -productVersion | cut -f 1 -d '.')
322 DARWIN_MINOR_VERSION = $(shell sw_vers -productVersion | cut -f 2 -d '.')
324 os_x_before = $(shell if [ $(DARWIN_MAJOR_VERSION) -le $(1) -a \
325 $(DARWIN_MINOR_VERSION) -le $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
327 os_x_after = $(shell if [ $(DARWIN_MAJOR_VERSION) -ge $(1) -a \
328 $(DARWIN_MINOR_VERSION) -ge $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
330 # Snow Leopards build environment has no longer restrictions as described above
331 HOSTCC = $(call os_x_before, 10, 5, "cc", "gcc")
332 KBUILD_HOSTCFLAGS += $(call os_x_before, 10, 4, "-traditional-cpp")
333 KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 5, "-multiply_defined suppress")
335 # macOS Mojave (10.14.X)
336 # Undefined symbols for architecture x86_64: "_PyArg_ParseTuple"
337 KBUILD_HOSTLDFLAGS += $(call os_x_after, 10, 14, "-lpython -dynamclib", "")
340 # Decide whether to build built-in, modular, or both.
341 # Normally, just do built-in.
346 # If we have only "make modules", don't compile built-in objects.
347 # When we're building modules with modversions, we need to consider
348 # the built-in objects during the descend as well, in order to
349 # make sure the checksums are up to date before we record them.
351 ifeq ($(MAKECMDGOALS),modules)
352 KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
355 # If we have "make <whatever> modules", compile modules
356 # in addition to whatever we do anyway.
357 # Just "make" or "make all" shall build modules as well
359 # U-Boot does not need modules
360 #ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
361 # KBUILD_MODULES := 1
364 #ifeq ($(MAKECMDGOALS),)
365 # KBUILD_MODULES := 1
368 # Check ths size of a binary:
371 # #2: Size limit in bytes (decimal or 0xhex)
373 actual=$$( wc -c $1 | awk '{print $$1}'); \
374 limit=$$( printf "%d" $2 ); \
375 if test $$actual -gt $$limit; then \
376 echo "$1 exceeds file size limit:" >&2; \
377 echo " limit: $$(printf %#x $$limit) bytes" >&2; \
378 echo " actual: $$(printf %#x $$actual) bytes" >&2; \
379 echo " excess: $$(printf %#x $$((actual - limit))) bytes" >&2;\
385 export KBUILD_MODULES KBUILD_BUILTIN
386 export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD
388 # We need some generic definitions (do not try to remake the file).
389 scripts/Kbuild.include: ;
390 include scripts/Kbuild.include
392 # Make variables (CC, etc...)
394 AS = $(CROSS_COMPILE)as
396 ifneq ($(shell $(CROSS_COMPILE)ld.bfd -v 2> /dev/null),)
397 LD = $(CROSS_COMPILE)ld.bfd
399 LD = $(CROSS_COMPILE)ld
401 CC = $(CROSS_COMPILE)gcc
403 AR = $(CROSS_COMPILE)ar
404 NM = $(CROSS_COMPILE)nm
405 LDR = $(CROSS_COMPILE)ldr
406 STRIP = $(CROSS_COMPILE)strip
407 OBJCOPY = $(CROSS_COMPILE)objcopy
408 OBJDUMP = $(CROSS_COMPILE)objdump
417 # The devicetree compiler and pylibfdt are automatically built unless DTC is
418 # provided. If DTC is provided, it is assumed the pylibfdt is available too.
419 DTC_INTREE := $(objtree)/scripts/dtc/dtc
421 DTC_MIN_VERSION := 010406
425 CHECKFLAGS := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
426 -Wbitwise -Wno-return-void -D__CHECK_ENDIAN__ $(CF)
428 KBUILD_CPPFLAGS := -D__KERNEL__ -D__UBOOT__
430 KBUILD_CFLAGS := -Wall -Wstrict-prototypes \
431 -Wno-format-security \
432 -fno-builtin -ffreestanding $(CSTD_FLAG)
433 KBUILD_CFLAGS += -fshort-wchar -fno-strict-aliasing
434 KBUILD_AFLAGS := -D__ASSEMBLY__
437 ifeq ($(cc-name),clang)
438 ifneq ($(CROSS_COMPILE),)
439 CLANG_TARGET := --target=$(notdir $(CROSS_COMPILE:%-=%))
440 GCC_TOOLCHAIN_DIR := $(dir $(shell which $(LD)))
441 CLANG_PREFIX := --prefix=$(GCC_TOOLCHAIN_DIR)
442 GCC_TOOLCHAIN := $(realpath $(GCC_TOOLCHAIN_DIR)/..)
444 ifneq ($(GCC_TOOLCHAIN),)
445 CLANG_GCC_TC := --gcc-toolchain=$(GCC_TOOLCHAIN)
447 KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
448 KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
449 KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
450 KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
453 # Don't generate position independent code
454 KBUILD_CFLAGS += $(call cc-option,-fno-PIE)
455 KBUILD_AFLAGS += $(call cc-option,-fno-PIE)
457 # Read UBOOTRELEASE from include/config/uboot.release (if it exists)
458 UBOOTRELEASE = $(shell cat include/config/uboot.release 2> /dev/null)
459 UBOOTVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
461 export VERSION PATCHLEVEL SUBLEVEL UBOOTRELEASE UBOOTVERSION
462 export ARCH CPU BOARD VENDOR SOC CPUDIR BOARDDIR
463 export CONFIG_SHELL HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE AS LD CC
464 export CPP AR NM LDR STRIP OBJCOPY OBJDUMP KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS
465 export MAKE LEX YACC AWK PERL PYTHON PYTHON2 PYTHON3
466 export HOSTCXX KBUILD_HOSTCXXFLAGS CHECK CHECKFLAGS DTC DTC_FLAGS
468 export KBUILD_CPPFLAGS NOSTDINC_FLAGS UBOOTINCLUDE OBJCOPYFLAGS KBUILD_LDFLAGS
469 export KBUILD_CFLAGS KBUILD_AFLAGS
471 export CC_VERSION_TEXT := $(shell $(CC) --version | head -n 1)
473 # When compiling out-of-tree modules, put MODVERDIR in the module
474 # tree rather than in the kernel tree. The kernel tree might
476 export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions
478 # Files to ignore in find ... statements
480 export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o \
481 -name CVS -o -name .pc -o -name .hg -o -name .git \) \
483 export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
484 --exclude CVS --exclude .pc --exclude .hg --exclude .git
486 # ===========================================================================
487 # Rules shared between *config targets and build targets
489 # Basic helpers built in scripts/
490 PHONY += scripts_basic
492 $(Q)$(MAKE) $(build)=scripts/basic
493 $(Q)rm -f .tmp_quiet_recordmcount
495 # To avoid any implicit rule to kick in, define an empty command.
496 scripts/basic/%: scripts_basic ;
498 PHONY += outputmakefile
499 # outputmakefile generates a Makefile in the output directory, if using a
500 # separate output directory. This allows convenient use of make in the
503 ifneq ($(KBUILD_SRC),)
504 $(Q)ln -fsn $(srctree) source
505 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile $(srctree)
508 # To make sure we do not include .config for any of the *config targets
509 # catch them early, and hand them over to scripts/kconfig/Makefile
510 # It is allowed to specify more targets when calling make, including
511 # mixing *config targets and build targets.
512 # For example 'make oldconfig all'.
513 # Detect when mixed targets is specified, and make a second invocation
514 # of make so .config is not included in this case either (for *config).
516 version_h := include/generated/version_autogenerated.h
517 timestamp_h := include/generated/timestamp_autogenerated.h
518 defaultenv_h := include/generated/defaultenv_autogenerated.h
519 dt_h := include/generated/dt.h
520 env_h := include/generated/environment.h
522 no-dot-config-targets := clean clobber mrproper distclean \
523 help %docs check% coccicheck \
524 ubootversion backup tests check qcheck tcheck pylint \
531 ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
532 ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
537 ifeq ($(KBUILD_EXTMOD),)
538 ifneq ($(filter config %config,$(MAKECMDGOALS)),)
540 ifneq ($(words $(MAKECMDGOALS)),1)
546 ifeq ($(mixed-targets),1)
547 # ===========================================================================
548 # We're called with mixed targets (*config and build targets).
549 # Handle them one by one.
551 PHONY += $(MAKECMDGOALS) __build_one_by_one
553 $(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
558 for i in $(MAKECMDGOALS); do \
559 $(MAKE) -f $(srctree)/Makefile $$i; \
563 ifeq ($(config-targets),1)
564 # ===========================================================================
565 # *config targets only - make sure prerequisites are updated, and descend
566 # in scripts/kconfig to make the *config target
568 KBUILD_DEFCONFIG := sandbox_defconfig
569 export KBUILD_DEFCONFIG KBUILD_KCONFIG
571 config: scripts_basic outputmakefile FORCE
572 $(Q)$(MAKE) $(build)=scripts/kconfig $@
574 %config: scripts_basic outputmakefile FORCE
575 $(Q)$(MAKE) $(build)=scripts/kconfig $@
578 # ===========================================================================
579 # Build targets only - this includes vmlinux, arch specific targets, clean
580 # targets and others. In general all targets except *config targets.
582 # Additional helpers built in scripts/
583 # Carefully list dependencies so we do not try to build scripts twice
586 scripts: scripts_basic scripts_dtc include/config/auto.conf
587 $(Q)$(MAKE) $(build)=$(@)
589 ifeq ($(dot-config),1)
591 -include include/config/auto.conf
593 # Read in dependencies to all Kconfig* files, make sure to run
594 # oldconfig if changes are detected.
595 -include include/config/auto.conf.cmd
597 # To avoid any implicit rule to kick in, define an empty command
598 $(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;
600 # If .config is newer than include/config/auto.conf, someone tinkered
601 # with it and forgot to run make oldconfig.
602 # if auto.conf.cmd is missing then we are probably in a cleaned tree so
603 # we execute the config step to be sure to catch updated Kconfig files
604 include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
605 $(Q)$(MAKE) -f $(srctree)/Makefile syncconfig
606 @# If the following part fails, include/config/auto.conf should be
607 @# deleted so "make silentoldconfig" will be re-run on the next build.
608 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf || \
609 { rm -f include/config/auto.conf; false; }
610 @# include/config.h has been updated after "make silentoldconfig".
611 @# We need to touch include/config/auto.conf so it gets newer
612 @# than include/config.h.
613 @# Otherwise, 'make silentoldconfig' would be invoked twice.
614 $(Q)touch include/config/auto.conf
616 u-boot.cfg spl/u-boot.cfg tpl/u-boot.cfg:
617 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf $(@)
619 -include include/autoconf.mk
620 -include include/autoconf.mk.dep
622 # We want to include arch/$(ARCH)/config.mk only when include/config/auto.conf
623 # is up-to-date. When we switch to a different board configuration, old CONFIG
624 # macros are still remaining in include/config/auto.conf. Without the following
625 # gimmick, wrong config.mk would be included leading nasty warnings/errors.
626 ifneq ($(wildcard $(KCONFIG_CONFIG)),)
627 ifneq ($(wildcard include/config/auto.conf),)
628 autoconf_is_old := $(shell find . -path ./$(KCONFIG_CONFIG) -newer \
629 include/config/auto.conf)
630 ifeq ($(autoconf_is_old),)
632 include arch/$(ARCH)/Makefile
637 # These are set by the arch-specific config.mk. Make sure they are exported
638 # so they can be used when building an EFI application.
639 export EFI_LDS # Filename of EFI link script in arch/$(ARCH)/lib
640 export EFI_CRT0 # Filename of EFI CRT0 in arch/$(ARCH)/lib
641 export EFI_RELOC # Filename of EFU relocation code in arch/$(ARCH)/lib
642 export CFLAGS_EFI # Compiler flags to add when building EFI app
643 export CFLAGS_NON_EFI # Compiler flags to remove when building EFI app
644 export EFI_TARGET # binutils target if EFI is natively supported
646 # If board code explicitly specified LDSCRIPT or CONFIG_SYS_LDSCRIPT, use
647 # that (or fail if absent). Otherwise, search for a linker script in a
651 #LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds.debug
652 ifdef CONFIG_SYS_LDSCRIPT
653 # need to strip off double quotes
654 LDSCRIPT := $(srctree)/$(CONFIG_SYS_LDSCRIPT:"%"=%)
658 # If there is no specified link script, we look in a number of places for it
660 ifeq ($(wildcard $(LDSCRIPT)),)
661 LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds
663 ifeq ($(wildcard $(LDSCRIPT)),)
664 LDSCRIPT := $(srctree)/$(CPUDIR)/u-boot.lds
666 ifeq ($(wildcard $(LDSCRIPT)),)
667 LDSCRIPT := $(srctree)/arch/$(ARCH)/cpu/u-boot.lds
672 # Dummy target needed, because used as prerequisite
673 include/config/auto.conf: ;
674 endif # $(dot-config)
676 ifdef CONFIG_CC_OPTIMIZE_FOR_DEBUG
677 KBUILD_HOSTCFLAGS := -Wall -Wstrict-prototypes -Og -g -fomit-frame-pointer \
678 $(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
679 KBUILD_HOSTCXXFLAGS := -Og -g $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
683 # Xtensa linker script cannot be preprocessed with -ansi because of
684 # preprocessor operations on strings that don't make C identifiers.
686 ifeq ($(CONFIG_XTENSA),)
690 ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
694 ifdef CONFIG_CC_OPTIMIZE_FOR_SPEED
698 ifdef CONFIG_CC_OPTIMIZE_FOR_DEBUG
704 export LTO_CFLAGS LTO_FINAL_LDFLAGS
706 ifeq ($(cc-name),clang)
708 LTO_FINAL_LDFLAGS += -flto
710 AR = $(shell $(CC) -print-prog-name=llvm-ar)
711 NM = $(shell $(CC) -print-prog-name=llvm-nm)
713 NPROC := $(shell nproc 2>/dev/null || echo 1)
714 LTO_CFLAGS += -flto=$(NPROC)
715 LTO_FINAL_LDFLAGS += -fuse-linker-plugin -flto=$(NPROC)
717 # use plugin aware tools
718 AR = $(CROSS_COMPILE)gcc-ar
719 NM = $(CROSS_COMPILE)gcc-nm
722 CFLAGS_NON_EFI += $(LTO_CFLAGS)
724 KBUILD_CFLAGS += $(LTO_CFLAGS)
727 ifeq ($(CONFIG_STACKPROTECTOR),y)
728 KBUILD_CFLAGS += $(call cc-option,-fstack-protector-strong)
729 CFLAGS_EFI += $(call cc-option,-fno-stack-protector)
731 KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
733 KBUILD_CFLAGS += $(call cc-option,-fno-delete-null-pointer-checks)
735 # disable pointer signed / unsigned warnings in gcc 4.0
736 KBUILD_CFLAGS += -Wno-pointer-sign
738 # disable stringop warnings in gcc 8+
739 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-truncation)
741 KBUILD_CFLAGS += $(call cc-disable-warning, zero-length-bounds)
742 KBUILD_CFLAGS += $(call cc-disable-warning, array-bounds)
743 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-overflow)
745 # Enabled with W=2, disabled by default as noisy
746 KBUILD_CFLAGS += $(call cc-disable-warning, maybe-uninitialized)
748 # change __FILE__ to the relative path from the srctree
749 KBUILD_CFLAGS += $(call cc-option,-fmacro-prefix-map=$(srctree)/=)
752 # $(KBUILD_AFLAGS) sets -g, which causes gcc to pass a suitable -g<format>
753 # option to the assembler.
756 # Report stack usage if supported
757 # ARC tools based on GCC 7.1 has an issue with stack usage
758 # with naked functions, see commit message for more details
760 ifeq ($(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-stack-usage.sh $(CC)),y)
761 KBUILD_CFLAGS += -fstack-usage
765 KBUILD_CFLAGS += $(call cc-option,-Wno-format-nonliteral)
766 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
768 ifdef CONFIG_CC_IS_CLANG
769 KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
770 KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
771 KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
772 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
773 # Quiet clang warning: comparison of unsigned expression < 0 is always false
774 KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
775 # CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
776 # source of a reference will be _MergedGlobals and not on of the whitelisted names.
777 # See modpost pattern 2
778 KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
779 KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
782 # These warnings generated too much noise in a regular build.
783 # Use make W=1 to enable them (see scripts/Makefile.extrawarn)
784 KBUILD_CFLAGS += $(call cc-disable-warning, unused-but-set-variable)
786 # Prohibit date/time macros, which would make the build non-deterministic
787 KBUILD_CFLAGS += $(call cc-option,-Werror=date-time)
789 include scripts/Makefile.extrawarn
791 # Add user supplied CPPFLAGS, AFLAGS and CFLAGS as the last assignments
792 KBUILD_CPPFLAGS += $(KCPPFLAGS)
793 KBUILD_AFLAGS += $(KAFLAGS)
794 KBUILD_CFLAGS += $(KCFLAGS)
796 KBUILD_HOSTCFLAGS += $(if $(CONFIG_TOOLS_DEBUG),-g)
798 # Use UBOOTINCLUDE when you must reference the include/ directory.
799 # Needed to be compatible with the O= option
802 $(if $(KBUILD_SRC), -I$(srctree)/include) \
803 $(if $(CONFIG_$(SPL_)SYS_THUMB_BUILD), \
804 $(if $(CONFIG_HAS_THUMB2), \
805 $(if $(CONFIG_CPU_V7M), \
806 -I$(srctree)/arch/arm/thumb1/include), \
807 -I$(srctree)/arch/arm/thumb1/include)) \
808 -I$(srctree)/arch/$(ARCH)/include \
809 -include $(srctree)/include/linux/kconfig.h
811 NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)
814 cpp_flags := $(KBUILD_CPPFLAGS) $(PLATFORM_CPPFLAGS) $(UBOOTINCLUDE) \
816 c_flags := $(KBUILD_CFLAGS) $(cpp_flags)
818 #########################################################################
819 # U-Boot objects....order is important (i.e. start must be first)
821 HAVE_VENDOR_COMMON_LIB = $(if $(wildcard $(srctree)/board/$(VENDOR)/common/Makefile),y,n)
823 libs-$(CONFIG_API) += api/
824 libs-$(HAVE_VENDOR_COMMON_LIB) += board/$(VENDOR)/common/
828 libs-$(CONFIG_OF_EMBED) += dts/
835 libs-$(CONFIG_SYS_FSL_DDR) += drivers/ddr/fsl/
836 libs-$(CONFIG_SYS_FSL_MMDC) += drivers/ddr/fsl/
837 libs-$(CONFIG_$(SPL_)ALTERA_SDRAM) += drivers/ddr/altera/
838 libs-y += drivers/usb/cdns3/
839 libs-y += drivers/usb/dwc3/
840 libs-y += drivers/usb/common/
841 libs-y += drivers/usb/emul/
842 libs-y += drivers/usb/eth/
843 libs-$(CONFIG_USB_DEVICE) += drivers/usb/gadget/
844 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/
845 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/udc/
846 libs-y += drivers/usb/host/
847 libs-y += drivers/usb/mtu3/
848 libs-y += drivers/usb/musb/
849 libs-y += drivers/usb/musb-new/
850 libs-y += drivers/usb/isp1760/
851 libs-y += drivers/usb/phy/
852 libs-y += drivers/usb/ulpi/
856 libs-$(CONFIG_$(SPL_TPL_)UNIT_TEST) += test/
857 libs-$(CONFIG_UT_ENV) += test/env/
858 libs-$(CONFIG_UT_OPTEE) += test/optee/
859 libs-$(CONFIG_UT_OVERLAY) += test/overlay/
861 libs-y += $(if $(BOARDDIR),board/$(BOARDDIR)/)
863 libs-y := $(sort $(libs-y))
865 u-boot-dirs := $(patsubst %/,%,$(filter %/, $(libs-y))) tools examples
867 u-boot-alldirs := $(sort $(u-boot-dirs) $(patsubst %/,%,$(filter %/, $(libs-))))
869 libs-y := $(patsubst %/, %/built-in.o, $(libs-y))
871 u-boot-init := $(head-y)
872 u-boot-main := $(libs-y)
876 ifeq ($(CONFIG_USE_PRIVATE_LIBGCC),y)
877 PLATFORM_LIBGCC = arch/$(ARCH)/lib/lib.a
879 PLATFORM_LIBGCC := -L $(shell dirname `$(CC) $(c_flags) -print-libgcc-file-name`) -lgcc
881 PLATFORM_LIBS += $(PLATFORM_LIBGCC)
883 ifdef CONFIG_CC_COVERAGE
884 KBUILD_CFLAGS += --coverage
885 PLATFORM_LIBGCC += -lgcov
889 export PLATFORM_LIBGCC
891 # Special flags for CPP when processing the linker script.
892 # Pass the version down so we can handle backwards compatibility
895 -include $(srctree)/include/u-boot/u-boot.lds.h \
897 $(shell $(LD) --version | \
898 sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')
900 #########################################################################
901 #########################################################################
903 ifneq ($(CONFIG_BOARD_SIZE_LIMIT),)
904 BOARD_SIZE_CHECK= @ $(call size_check,$@,$(CONFIG_BOARD_SIZE_LIMIT))
909 ifneq ($(CONFIG_SPL_SIZE_LIMIT),0x0)
910 SPL_SIZE_CHECK = @$(call size_check,$@,$$(tools/spl_size_limit))
915 ifneq ($(CONFIG_TPL_SIZE_LIMIT),0x0)
916 TPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_TPL_SIZE_LIMIT))
921 ifneq ($(CONFIG_VPL_SIZE_LIMIT),0x0)
922 VPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_VPL_SIZE_LIMIT))
927 # Statically apply RELA-style relocations (currently arm64 only)
928 # This is useful for arm64 where static relocation needs to be performed on
929 # the raw binary, but certain simulators only accept an ELF file (but don't
930 # do the relocation).
931 ifneq ($(CONFIG_STATIC_RELA),)
932 # $(2) is u-boot ELF, $(3) is u-boot bin, $(4) is text base
933 quiet_cmd_static_rela = RELOC $@
935 tools/relocate-rela $(3) $(2)
937 quiet_cmd_static_rela =
941 # Always append INPUTS so that arch config.mk's can add custom ones
942 INPUTS-y += u-boot.srec u-boot.bin u-boot.sym System.map binary_size_check
944 INPUTS-$(CONFIG_ONENAND_U_BOOT) += u-boot-onenand.bin
945 ifeq ($(CONFIG_SPL_FSL_PBL),y)
946 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot-with-spl-pbl.bin
948 ifneq ($(CONFIG_NXP_ESBC), y)
949 # For Secure Boot The Image needs to be signed and Header must also
950 # be included. So The image has to be built explicitly
951 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot.pbl
954 INPUTS-$(CONFIG_SPL) += spl/u-boot-spl.bin
955 ifeq ($(CONFIG_MX6)$(CONFIG_IMX_HAB), yy)
956 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
958 ifeq ($(CONFIG_MX7)$(CONFIG_IMX_HAB), yy)
959 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
961 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot.img
964 INPUTS-$(CONFIG_TPL) += tpl/u-boot-tpl.bin
965 INPUTS-$(CONFIG_VPL) += vpl/u-boot-vpl.bin
967 # Allow omitting the .dtb output if it is not normally used
968 INPUTS-$(CONFIG_OF_SEPARATE) += $(if $(CONFIG_OF_OMIT_DTB),dts/dt.dtb,u-boot.dtb)
969 ifeq ($(CONFIG_SPL_FRAMEWORK),y)
970 INPUTS-$(CONFIG_OF_SEPARATE) += u-boot-dtb.img
972 INPUTS-$(CONFIG_SANDBOX) += u-boot.dtb
973 ifneq ($(CONFIG_SPL_TARGET),)
974 INPUTS-$(CONFIG_SPL) += $(CONFIG_SPL_TARGET:"%"=%)
976 INPUTS-$(CONFIG_REMAKE_ELF) += u-boot.elf
977 INPUTS-$(CONFIG_EFI_APP) += u-boot-app.efi
978 INPUTS-$(CONFIG_EFI_STUB) += u-boot-payload.efi
980 # Generate this input file for binman
981 ifeq ($(CONFIG_SPL),)
982 INPUTS-$(CONFIG_ARCH_MEDIATEK) += u-boot-mtk.bin
985 # Add optional build target if defined in board/cpu/soc headers
986 ifneq ($(CONFIG_BUILD_TARGET),)
987 INPUTS-y += $(CONFIG_BUILD_TARGET:"%"=%)
990 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
991 INPUTS-y += init_sp_bss_offset_check
994 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
995 INPUTS-y += u-boot-with-dtb.bin
998 ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
999 # On ARM64 this target is produced by binman so we don't need this dep
1000 ifeq ($(CONFIG_ARM64),y)
1001 ifeq ($(CONFIG_SPL),y)
1002 # TODO: Get binman to generate this too
1003 INPUTS-y += u-boot-rockchip.bin
1006 ifeq ($(CONFIG_SPL),y)
1007 # Generate these inputs for binman which will create the output files
1008 INPUTS-y += idbloader.img u-boot.img
1013 INPUTS-$(CONFIG_X86) += u-boot-x86-start16.bin u-boot-x86-reset16.bin \
1014 $(if $(CONFIG_SPL_X86_16BIT_INIT),spl/u-boot-spl.bin) \
1015 $(if $(CONFIG_TPL_X86_16BIT_INIT),tpl/u-boot-tpl.bin)
1017 LDFLAGS_u-boot += $(LDFLAGS_FINAL)
1019 # Avoid 'Not enough room for program headers' error on binutils 2.28 onwards.
1020 LDFLAGS_u-boot += $(call ld-option, --no-dynamic-linker)
1023 LDFLAGS_u-boot += -z notext
1025 LDFLAGS_u-boot += --build-id=none
1027 ifeq ($(CONFIG_ARC)$(CONFIG_NIOS2)$(CONFIG_X86)$(CONFIG_XTENSA),)
1028 LDFLAGS_u-boot += -Ttext $(CONFIG_SYS_TEXT_BASE)
1031 # insure the checker run with the right endianness
1032 CHECKFLAGS += $(if $(CONFIG_CPU_BIG_ENDIAN),-mbig-endian,-mlittle-endian)
1034 # the checker needs the correct machine size
1035 CHECKFLAGS += $(if $(CONFIG_64BIT),-m64,-m32)
1037 # Normally we fill empty space with 0xff
1038 quiet_cmd_objcopy = OBJCOPY $@
1039 cmd_objcopy = $(OBJCOPY) --gap-fill=0xff $(OBJCOPYFLAGS) \
1040 $(OBJCOPYFLAGS_$(@F)) $< $@
1042 # Provide a version which does not do this, for use by EFI
1043 quiet_cmd_zobjcopy = OBJCOPY $@
1044 cmd_zobjcopy = $(OBJCOPY) $(OBJCOPYFLAGS) $(OBJCOPYFLAGS_$(@F)) $< $@
1046 quiet_cmd_efipayload = OBJCOPY $@
1047 cmd_efipayload = $(OBJCOPY) -I binary -O $(EFIPAYLOAD_BFDTARGET) -B $(EFIPAYLOAD_BFDARCH) $< $@
1049 MKIMAGEOUTPUT ?= /dev/null
1051 quiet_cmd_mkimage = MKIMAGE $@
1052 cmd_mkimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) -d $< $@ \
1053 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1055 quiet_cmd_mkfitimage = MKIMAGE $@
1056 cmd_mkfitimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) \
1057 -f $(U_BOOT_ITS) -p $(CONFIG_FIT_EXTERNAL_OFFSET) $@ \
1058 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1060 quiet_cmd_cat = CAT $@
1061 cmd_cat = cat $(filter-out $(PHONY), $^) > $@
1063 append = cat $(filter-out $< $(PHONY), $^) >> $@
1065 quiet_cmd_pad_cat = CAT $@
1066 cmd_pad_cat = $(cmd_objcopy) && $(append) || { rm -f $@; false; }
1068 quiet_cmd_lzma = LZMA $@
1069 cmd_lzma = lzma -c -z -k -9 $< > $@
1073 quiet_cmd_cfgcheck = CFGCHK $2
1074 cmd_cfgcheck = $(srctree)/scripts/check-config.sh $2 \
1075 $(srctree)/scripts/config_whitelist.txt $(srctree)
1077 quiet_cmd_ofcheck = OFCHK $2
1078 cmd_ofcheck = $(srctree)/scripts/check-of.sh $2 \
1079 $(srctree)/scripts/of_allowlist.txt
1081 # Concat the value of all the CONFIGs (result is 'y' or 'yy', etc. )
1082 got = $(foreach cfg,$(1),$($(cfg)))
1084 # expected value 'y for each one
1085 expect = $(foreach cfg,$(1),y)
1087 # Show a deprecation message
1089 # 1: List of CONFIG_DM_... to migrate to (e.g. "CONFIG_DM_MMC CONFIG_BLK")
1090 # 2: Name of component (e.g . "Ethernet drivers")
1091 # 3: Release deadline (e.g. "v202.07")
1092 # 4: Condition to require before checking (e.g. "$(CONFIG_NET)")
1093 # Note: Script avoids bash construct, hence the strange double 'if'
1094 # (patches welcome!)
1096 @if [ -n "$(strip $(4))" ]; then if [ "$(got)" != "$(expect)" ]; then \
1097 echo >&2 "===================== WARNING ======================"; \
1098 echo >&2 "This board does not use $(firstword $(1)) (Driver Model"; \
1099 echo >&2 "for $(2)). Please update the board to use"; \
1100 echo >&2 "$(firstword $(1)) before the $(3) release. Failure to"; \
1101 echo >&2 "update by the deadline may result in board removal."; \
1102 echo >&2 "See doc/develop/driver-model/migration.rst for more info."; \
1103 echo >&2 "===================================================="; \
1111 all: .binman_stamp inputs
1112 ifeq ($(CONFIG_BINMAN),y)
1113 $(call if_changed,binman)
1116 # Timestamp file to make sure that binman always runs
1117 .binman_stamp: FORCE
1120 ifeq ($(CONFIG_DEPRECATED),y)
1121 $(warning "You have deprecated configuration options enabled in your .config! Please check your configuration.")
1123 ifeq ($(CONFIG_OF_EMBED)$(CONFIG_EFI_APP),y)
1124 @echo >&2 "===================== WARNING ======================"
1125 @echo >&2 "CONFIG_OF_EMBED is enabled. This option should only"
1126 @echo >&2 "be used for debugging purposes. Please use"
1127 @echo >&2 "CONFIG_OF_SEPARATE for boards in mainline."
1128 @echo >&2 "See doc/develop/devicetree/control.rst for more info."
1129 @echo >&2 "===================================================="
1131 ifneq ($(CONFIG_SPL_FIT_GENERATOR),)
1132 @echo >&2 "===================== WARNING ======================"
1133 @echo >&2 "This board uses CONFIG_SPL_FIT_GENERATOR. Please migrate"
1134 @echo >&2 "to binman instead, to avoid the proliferation of"
1135 @echo >&2 "arch-specific scripts with no tests."
1136 @echo >&2 "===================================================="
1138 ifneq ($(CONFIG_DM),y)
1139 @echo >&2 "===================== WARNING ======================"
1140 @echo >&2 "This board does not use CONFIG_DM. CONFIG_DM will be"
1141 @echo >&2 "compulsory starting with the v2020.01 release."
1142 @echo >&2 "Failure to update may result in board removal."
1143 @echo >&2 "See doc/develop/driver-model/migration.rst for more info."
1144 @echo >&2 "===================================================="
1146 $(call deprecated,CONFIG_WDT,DM watchdog,v2019.10,\
1147 $(CONFIG_WATCHDOG)$(CONFIG_HW_WATCHDOG))
1148 $(call deprecated,CONFIG_DM_ETH,Ethernet drivers,v2020.07,$(CONFIG_NET))
1149 $(call deprecated,CONFIG_DM_I2C,I2C drivers,v2022.04,$(CONFIG_SYS_I2C_LEGACY))
1150 $(call deprecated,CONFIG_DM_KEYBOARD,Keyboard drivers,v2022.10,$(CONFIG_KEYBOARD))
1151 @# CONFIG_SYS_TIMER_RATE has brackets in it for some boards which
1152 @# confuses this rule. Use if() to send just a single character which
1153 @# is enable to tell 'deprecated' that one of these symbols exists
1154 $(call deprecated,CONFIG_TIMER,Timer drivers,v2023.01,$(if $(strip $(CONFIG_SYS_TIMER_RATE)$(CONFIG_SYS_TIMER_COUNTER)),x))
1155 $(call deprecated,CONFIG_DM_SERIAL,Serial drivers,v2023.04,$(CONFIG_SERIAL))
1156 $(call deprecated,CONFIG_DM_SCSI,SCSI drivers,v2023.04,$(CONFIG_SCSI))
1157 @# Check that this build does not use CONFIG options that we do not
1158 @# know about unless they are in Kconfig. All the existing CONFIG
1159 @# options are whitelisted, so new ones should not be added.
1160 $(call cmd,cfgcheck,u-boot.cfg)
1161 @# Check that this build does not override OF_HAS_PRIOR_STAGE by
1162 @# disabling OF_BOARD.
1163 $(call cmd,ofcheck,$(KCONFIG_CONFIG))
1169 $(Q)$(MAKE) $(build)=dts dtbs
1171 quiet_cmd_copy = COPY $@
1174 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1176 ifeq ($(CONFIG_MULTI_DTB_FIT_LZO),y)
1177 FINAL_DTB_CONTAINER = fit-dtb.blob.lzo
1178 else ifeq ($(CONFIG_MULTI_DTB_FIT_GZIP),y)
1179 FINAL_DTB_CONTAINER = fit-dtb.blob.gz
1181 FINAL_DTB_CONTAINER = fit-dtb.blob
1184 fit-dtb.blob.gz: fit-dtb.blob
1187 fit-dtb.blob.lzo: fit-dtb.blob
1190 fit-dtb.blob: dts/dt.dtb FORCE
1191 $(call if_changed,mkimage)
1192 ifneq ($(SOURCE_DATE_EPOCH),)
1193 touch -d @$(SOURCE_DATE_EPOCH) fit-dtb.blob
1194 chmod 0600 fit-dtb.blob
1197 MKIMAGEFLAGS_fit-dtb.blob = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1199 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) -d /dev/null
1201 MKIMAGEFLAGS_fit-dtb.blob += -B 0x8
1204 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(EXT_DTB)
1205 $(call if_changed,cat)
1207 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(FINAL_DTB_CONTAINER)
1208 $(call if_changed,cat)
1211 u-boot.bin: u-boot-fit-dtb.bin FORCE
1212 $(call if_changed,copy)
1214 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1215 $(call if_changed,cat)
1217 else ifeq ($(CONFIG_OF_SEPARATE).$(CONFIG_OF_OMIT_DTB),y.)
1218 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1219 $(call if_changed,cat)
1221 u-boot.bin: u-boot-dtb.bin FORCE
1222 $(call if_changed,copy)
1224 u-boot.bin: u-boot-nodtb.bin FORCE
1225 $(call if_changed,copy)
1228 # we call Makefile in arch/arm/mach-imx which
1229 # has targets which are dependent on targets defined
1230 # here. make could not resolve them and we must ensure
1231 # that they are finished before calling imx targets
1232 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1233 IMX_DEPS = u-boot-fit-dtb.bin
1236 %.imx: $(IMX_DEPS) %.bin
1237 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1241 $(Q)$(MAKE) $(build)=arch/arm/cpu/armv7/vf610 $@
1243 quiet_cmd_copy = COPY $@
1246 u-boot.dtb: dts/dt.dtb
1249 OBJCOPYFLAGS_u-boot.hex := -O ihex
1251 OBJCOPYFLAGS_u-boot.srec := -O srec
1253 u-boot.hex u-boot.srec: u-boot FORCE
1254 $(call if_changed,objcopy)
1256 OBJCOPYFLAGS_u-boot-elf.srec := $(OBJCOPYFLAGS_u-boot.srec)
1258 u-boot-elf.srec: u-boot.elf FORCE
1259 $(call if_changed,objcopy)
1261 OBJCOPYFLAGS_u-boot-spl.srec = $(OBJCOPYFLAGS_u-boot.srec)
1263 spl/u-boot-spl.srec: spl/u-boot-spl FORCE
1264 $(call if_changed,objcopy)
1267 $(Q)$(MAKE) $(build)=arch/arm/mach-rmobile $@
1269 OBJCOPYFLAGS_u-boot-nodtb.bin := -O binary \
1270 $(if $(CONFIG_X86_16BIT_INIT),-R .start16 -R .resetvec) \
1271 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR),$(if $(CONFIG_OF_EMBED),,-R .bootpg -R .resetvec))
1273 binary_size_check: u-boot-nodtb.bin FORCE
1274 @file_size=$(shell wc -c u-boot-nodtb.bin | awk '{print $$1}') ; \
1275 map_size=$(shell cat u-boot.map | \
1276 awk '/_image_copy_start/ {start = $$1} /_image_binary_end/ {end = $$1} END {if (start != "" && end != "") print "ibase=16; " toupper(end) " - " toupper(start)}' \
1279 if [ "" != "$$map_size" ]; then \
1280 if test $$map_size -ne $$file_size; then \
1281 echo "u-boot.map shows a binary size of $$map_size" >&2 ; \
1282 echo " but u-boot-nodtb.bin shows $$file_size" >&2 ; \
1287 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
1288 ifneq ($(CONFIG_SYS_MALLOC_F_LEN),)
1289 subtract_sys_malloc_f_len = space=$$(($${space} - $(CONFIG_SYS_MALLOC_F_LEN)))
1291 subtract_sys_malloc_f_len = true
1293 # The 1/4 margin below is somewhat arbitrary. The likely initial SP usage is
1294 # so low that the DTB could probably use 90%+ of the available space, for
1295 # current values of CONFIG_SYS_INIT_SP_BSS_OFFSET at least. However, let's be
1296 # safe for now and tweak this later if space becomes tight.
1297 # A rejected alternative would be to check that some absolute minimum stack
1298 # space was available. However, since CONFIG_SYS_INIT_SP_BSS_OFFSET is
1299 # deliberately build-specific, to take account of build-to-build stack usage
1300 # differences due to different feature sets, there is no common absolute value
1302 init_sp_bss_offset_check: u-boot.dtb FORCE
1303 @dtb_size=$(shell wc -c u-boot.dtb | awk '{print $$1}') ; \
1304 space=$(CONFIG_SYS_INIT_SP_BSS_OFFSET) ; \
1305 $(subtract_sys_malloc_f_len) ; \
1306 quarter_space=$$(($${space} / 4)) ; \
1307 if [ $${dtb_size} -gt $${quarter_space} ]; then \
1308 echo "u-boot.dtb is larger than 1 quarter of " >&2 ; \
1309 echo "(CONFIG_SYS_INIT_SP_BSS_OFFSET - CONFIG_SYS_MALLOC_F_LEN)" >&2 ; \
1314 shell_cmd = { $(call echo-cmd,$(1)) $(cmd_$(1)); }
1316 quiet_cmd_objcopy_uboot = OBJCOPY $@
1317 ifdef cmd_static_rela
1318 cmd_objcopy_uboot = $(cmd_objcopy) && $(call shell_cmd,static_rela,$<,$@,$(CONFIG_SYS_TEXT_BASE)) || { rm -f $@; false; }
1320 cmd_objcopy_uboot = $(cmd_objcopy)
1323 u-boot-nodtb.bin: u-boot FORCE
1324 $(call if_changed,objcopy_uboot)
1329 $(LDR) -T $(CONFIG_CPU) -c $@ $< $(LDR_FLAGS)
1333 # ---------------------------------------------------------------------------
1334 # Use 'make BINMAN_DEBUG=1' to enable debugging
1335 # Use 'make BINMAN_VERBOSE=3' to set vebosity level
1336 default_dt := $(if $(DEVICE_TREE),$(DEVICE_TREE),$(CONFIG_DEFAULT_DEVICE_TREE))
1338 quiet_cmd_binman = BINMAN $@
1339 cmd_binman = $(srctree)/tools/binman/binman $(if $(BINMAN_DEBUG),-D) \
1340 $(foreach f,$(BINMAN_TOOLPATHS),--toolpath $(f)) \
1341 --toolpath $(objtree)/tools \
1342 $(if $(BINMAN_VERBOSE),-v$(BINMAN_VERBOSE)) \
1343 build -u -d u-boot.dtb -O . -m --allow-missing \
1345 -I . -I $(srctree) -I $(srctree)/board/$(BOARDDIR) \
1346 -I arch/$(ARCH)/dts -a of-list=$(CONFIG_OF_LIST) \
1347 $(foreach f,$(BINMAN_INDIRS),-I $(f)) \
1348 -a atf-bl31-path=${BL31} \
1349 -a tee-os-path=${TEE} \
1350 -a opensbi-path=${OPENSBI} \
1351 -a default-dt=$(default_dt) \
1352 -a scp-path=$(SCP) \
1353 -a spl-bss-pad=$(if $(CONFIG_SPL_SEPARATE_BSS),,1) \
1354 -a tpl-bss-pad=$(if $(CONFIG_TPL_SEPARATE_BSS),,1) \
1355 -a spl-dtb=$(CONFIG_SPL_OF_REAL) \
1356 -a tpl-dtb=$(CONFIG_TPL_OF_REAL) \
1357 -a pre-load-key-path=${PRE_LOAD_KEY_PATH} \
1360 OBJCOPYFLAGS_u-boot.ldr.hex := -I binary -O ihex
1362 OBJCOPYFLAGS_u-boot.ldr.srec := -I binary -O srec
1364 u-boot.ldr.hex u-boot.ldr.srec: u-boot.ldr FORCE
1365 $(call if_changed,objcopy)
1368 # U-Boot entry point, needed for booting of full-blown U-Boot
1369 # from the SPL U-Boot version.
1371 ifndef CONFIG_SYS_UBOOT_START
1372 CONFIG_SYS_UBOOT_START := $(CONFIG_SYS_TEXT_BASE)
1375 # Boards with more complex image requirements can provide an .its source file
1376 # or a generator script
1377 # NOTE: Please do not use this. We are migrating away from Makefile rules to use
1379 ifneq ($(CONFIG_SPL_FIT_SOURCE),"")
1380 U_BOOT_ITS := u-boot.its
1381 $(U_BOOT_ITS): $(subst ",,$(CONFIG_SPL_FIT_SOURCE))
1382 $(call if_changed,copy)
1384 ifneq ($(CONFIG_USE_SPL_FIT_GENERATOR),)
1385 U_BOOT_ITS := u-boot.its
1386 ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-rockchip/make_fit_atf.py")
1387 U_BOOT_ITS_DEPS += u-boot
1389 $(U_BOOT_ITS): $(U_BOOT_ITS_DEPS) FORCE
1390 $(srctree)/$(CONFIG_SPL_FIT_GENERATOR) \
1391 $(patsubst %,arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) > $@
1395 ifdef CONFIG_SPL_LOAD_FIT
1396 MKIMAGEFLAGS_u-boot.img = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1397 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1398 -p $(CONFIG_FIT_EXTERNAL_OFFSET) \
1399 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board" -E \
1400 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(DEVICE_TREE))) \
1401 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) \
1402 $(patsubst %,-b arch/$(ARCH)/dts/%.dtbo,$(subst ",,$(CONFIG_OF_OVERLAY_LIST)))
1404 MKIMAGEFLAGS_u-boot.img = -A $(ARCH) -T firmware -C none -O u-boot \
1405 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1406 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1407 MKIMAGEFLAGS_u-boot-ivt.img = -A $(ARCH) -T firmware_ivt -C none -O u-boot \
1408 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1409 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1410 u-boot-ivt.img: MKIMAGEOUTPUT = u-boot-ivt.img.log
1413 MKIMAGEFLAGS_u-boot-dtb.img = $(MKIMAGEFLAGS_u-boot.img)
1415 # Some boards have the kwbimage.cfg file written in advance, while some
1416 # other boards generate it on the fly during the build in the build tree.
1417 # Let's check if the file exists in the build tree first, otherwise we
1418 # fall back to use the one in the source tree.
1419 KWD_CONFIG_FILE = $(shell \
1420 if [ -f $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%) ]; then \
1421 echo -n $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1423 echo -n $(srctree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1426 MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
1427 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE)
1429 MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
1430 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1431 $(if $(KEYDIR),-k $(KEYDIR))
1433 MKIMAGEFLAGS_u-boot.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1434 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -A $(ARCH) -T pblimage
1436 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1437 UBOOT_BIN := u-boot-with-dtb.bin
1439 UBOOT_BIN := u-boot.bin
1442 MKIMAGEFLAGS_u-boot-lzma.img = -A $(ARCH) -T standalone -C lzma -O u-boot \
1443 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1444 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1446 u-boot.bin.lzma: u-boot.bin FORCE
1447 $(call if_changed,lzma)
1449 u-boot-lzma.img: u-boot.bin.lzma FORCE
1450 $(call if_changed,mkimage)
1452 u-boot-dtb.img u-boot.img u-boot.kwb u-boot.pbl u-boot-ivt.img: \
1453 $(if $(CONFIG_SPL_LOAD_FIT),u-boot-nodtb.bin \
1454 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1455 ,$(UBOOT_BIN)) FORCE
1456 $(call if_changed,mkimage)
1459 ifeq ($(CONFIG_SPL_LOAD_FIT_FULL),y)
1460 MKIMAGEFLAGS_u-boot.itb =
1462 MKIMAGEFLAGS_u-boot.itb = -E
1464 MKIMAGEFLAGS_u-boot.itb += -B 0x8
1467 u-boot.itb: u-boot-nodtb.bin \
1468 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1470 $(call if_changed,mkfitimage)
1474 u-boot-spl.kwb: u-boot.bin spl/u-boot-spl.bin FORCE
1475 $(call if_changed,mkimage)
1477 u-boot.sha1: u-boot.bin
1478 tools/ubsha1 u-boot.bin
1481 $(OBJDUMP) -d $< > $@
1483 ifneq ($(CONFIG_SPL_PAYLOAD),)
1484 SPL_PAYLOAD := $(CONFIG_SPL_PAYLOAD:"%"=%)
1486 SPL_PAYLOAD := u-boot.bin
1489 SPL_IMAGE := $(CONFIG_SPL_IMAGE:"%"=%)
1491 OBJCOPYFLAGS_u-boot-with-spl.bin = -I binary -O binary \
1492 --pad-to=$(CONFIG_SPL_PAD_TO)
1493 u-boot-with-spl.bin: $(SPL_IMAGE) $(SPL_PAYLOAD) FORCE
1494 $(call if_changed,pad_cat)
1496 ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
1499 ifeq ($(CONFIG_SPL)$(CONFIG_TPL),yy)
1500 MKIMAGEFLAGS_u-boot-tpl-rockchip.bin = -n $(CONFIG_SYS_SOC) -T rksd
1501 tpl/u-boot-tpl-rockchip.bin: tpl/u-boot-tpl.bin FORCE
1502 $(call if_changed,mkimage)
1503 idbloader.img: tpl/u-boot-tpl-rockchip.bin spl/u-boot-spl.bin FORCE
1504 $(call if_changed,cat)
1506 MKIMAGEFLAGS_idbloader.img = -n $(CONFIG_SYS_SOC) -T rksd
1507 idbloader.img: spl/u-boot-spl.bin FORCE
1508 $(call if_changed,mkimage)
1511 ifeq ($(CONFIG_ARM64),y)
1512 OBJCOPYFLAGS_u-boot-rockchip.bin = -I binary -O binary \
1513 --pad-to=$(CONFIG_SPL_PAD_TO) --gap-fill=0xff
1514 u-boot-rockchip.bin: idbloader.img u-boot.itb FORCE
1515 $(call if_changed,pad_cat)
1516 endif # CONFIG_ARM64
1518 endif # CONFIG_ARCH_ROCKCHIP
1520 ifeq ($(CONFIG_ARCH_LPC32XX)$(CONFIG_SPL),yy)
1521 MKIMAGEFLAGS_lpc32xx-spl.img = -T lpc32xximage -a $(CONFIG_SPL_TEXT_BASE)
1523 lpc32xx-spl.img: spl/u-boot-spl.bin FORCE
1524 $(call if_changed,mkimage)
1526 OBJCOPYFLAGS_lpc32xx-boot-0.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1528 lpc32xx-boot-0.bin: lpc32xx-spl.img FORCE
1529 $(call if_changed,objcopy)
1531 OBJCOPYFLAGS_lpc32xx-boot-1.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1533 lpc32xx-boot-1.bin: lpc32xx-spl.img FORCE
1534 $(call if_changed,objcopy)
1536 lpc32xx-full.bin: lpc32xx-boot-0.bin lpc32xx-boot-1.bin u-boot.img FORCE
1537 $(call if_changed,cat)
1541 OBJCOPYFLAGS_u-boot-with-tpl.bin = -I binary -O binary \
1542 --pad-to=$(CONFIG_TPL_PAD_TO)
1543 tpl/u-boot-with-tpl.bin: tpl/u-boot-tpl.bin u-boot.bin FORCE
1544 $(call if_changed,pad_cat)
1546 SPL: spl/u-boot-spl.bin FORCE
1547 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1549 ifeq ($(CONFIG_ARCH_IMX8M)$(CONFIG_ARCH_IMX8), y)
1550 ifeq ($(CONFIG_SPL_LOAD_IMX_CONTAINER), y)
1551 u-boot.cnt: u-boot.bin FORCE
1552 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1554 flash.bin: spl/u-boot-spl.bin u-boot.cnt FORCE
1555 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1557 ifeq ($(CONFIG_BINMAN),y)
1558 flash.bin: spl/u-boot-spl.bin $(INPUTS-y) FORCE
1559 $(call if_changed,binman)
1561 flash.bin: spl/u-boot-spl.bin u-boot.itb FORCE
1562 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1567 u-boot.uim: u-boot.bin FORCE
1568 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1570 u-boot-with-spl.imx u-boot-with-nand-spl.imx: SPL $(if $(CONFIG_OF_SEPARATE),u-boot.img,u-boot.uim) FORCE
1571 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1573 MKIMAGEFLAGS_u-boot.ubl = -n $(UBL_CONFIG) -T ublimage -e $(CONFIG_SYS_TEXT_BASE)
1575 u-boot.ubl: u-boot-with-spl.bin FORCE
1576 $(call if_changed,mkimage)
1578 MKIMAGEFLAGS_u-boot-spl.ais = -s -n $(if $(CONFIG_AIS_CONFIG_FILE), \
1579 $(srctree)/$(CONFIG_AIS_CONFIG_FILE:"%"=%),"/dev/null") \
1580 -T aisimage -e $(CONFIG_SPL_TEXT_BASE)
1581 spl/u-boot-spl.ais: spl/u-boot-spl.bin FORCE
1582 $(call if_changed,mkimage)
1584 OBJCOPYFLAGS_u-boot.ais = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1585 u-boot.ais: spl/u-boot-spl.ais u-boot.img FORCE
1586 $(call if_changed,pad_cat)
1588 u-boot-signed.sb: u-boot.bin spl/u-boot-spl.bin
1589 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot-signed.sb
1590 u-boot.sb: u-boot.bin spl/u-boot-spl.bin
1591 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot.sb
1593 MKIMAGEFLAGS_u-boot-spl.img = -A $(ARCH) -T firmware -C none \
1594 -a $(CONFIG_SPL_TEXT_BASE) -e $(CONFIG_SPL_TEXT_BASE) -n XLOADER
1595 spl/u-boot-spl.img: spl/u-boot-spl.bin FORCE
1596 $(call if_changed,mkimage)
1598 ifneq ($(CONFIG_ARCH_SOCFPGA),)
1599 quiet_cmd_gensplx4 = GENSPLX4 $@
1600 cmd_gensplx4 = $(OBJCOPY) -I binary -O binary --gap-fill=0x0 \
1601 --pad-to=$(CONFIG_SPL_PAD_TO) \
1602 spl/u-boot-spl.sfp spl/u-boot-spl.sfp && \
1603 cat spl/u-boot-spl.sfp spl/u-boot-spl.sfp \
1604 spl/u-boot-spl.sfp spl/u-boot-spl.sfp > $@ || { rm -f $@; false; }
1605 spl/u-boot-splx4.sfp: spl/u-boot-spl.sfp FORCE
1606 $(call if_changed,gensplx4)
1608 quiet_cmd_socboot = SOCBOOT $@
1609 cmd_socboot = cat spl/u-boot-splx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1610 u-boot-with-spl.sfp: spl/u-boot-splx4.sfp u-boot.img FORCE
1611 $(call if_changed,socboot)
1613 quiet_cmd_gensplpadx4 = GENSPLPADX4 $@
1614 cmd_gensplpadx4 = dd if=/dev/zero of=spl/u-boot-spl.pad bs=64 count=1024 ; \
1615 cat spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1616 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1617 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1618 spl/u-boot-spl.sfp spl/u-boot-spl.pad > $@ || \
1619 { rm -f $@ spl/u-boot-spl.pad; false; }
1620 u-boot-spl-padx4.sfp: spl/u-boot-spl.sfp FORCE
1621 $(call if_changed,gensplpadx4)
1623 quiet_cmd_socnandboot = SOCNANDBOOT $@
1624 cmd_socnandboot = cat u-boot-spl-padx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1625 u-boot-with-nand-spl.sfp: u-boot-spl-padx4.sfp u-boot.img FORCE
1626 $(call if_changed,socnandboot)
1630 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1631 u-boot-with-dtb.bin: u-boot.bin u-boot.dtb \
1632 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR), u-boot-br.bin) FORCE
1633 $(call if_changed,binman)
1635 ifeq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR),y)
1636 OBJCOPYFLAGS_u-boot-br.bin := -O binary -j .bootpg -j .resetvec
1637 u-boot-br.bin: u-boot FORCE
1638 $(call if_changed,objcopy)
1642 quiet_cmd_ldr = LD $@
1643 cmd_ldr = $(LD) $(LDFLAGS_$(@F)) \
1644 $(filter-out FORCE,$^) -o $@
1647 OBJCOPYFLAGS_u-boot-x86-start16.bin := -O binary -j .start16
1648 u-boot-x86-start16.bin: u-boot FORCE
1649 $(call if_changed,objcopy)
1651 OBJCOPYFLAGS_u-boot-x86-reset16.bin := -O binary -j .resetvec
1652 u-boot-x86-reset16.bin: u-boot FORCE
1653 $(call if_changed,objcopy)
1657 OBJCOPYFLAGS_u-boot-app.efi := $(OBJCOPYFLAGS_EFI)
1658 u-boot-app.efi: u-boot FORCE
1659 $(call if_changed,zobjcopy)
1661 u-boot.bin.o: u-boot.bin FORCE
1662 $(call if_changed,efipayload)
1664 u-boot-payload.lds: $(LDSCRIPT_EFI) FORCE
1665 $(call if_changed_dep,cpp_lds)
1667 # Rule to link the EFI payload which contains a stub and a U-Boot binary
1668 quiet_cmd_u-boot_payload ?= LD $@
1669 cmd_u-boot_payload ?= $(LD) $(LDFLAGS_EFI_PAYLOAD) -o $@ \
1670 -T u-boot-payload.lds arch/x86/cpu/call32.o \
1671 lib/efi/efi.o lib/efi/efi_stub.o u-boot.bin.o \
1672 $(addprefix arch/$(ARCH)/lib/,$(EFISTUB))
1674 u-boot-payload: u-boot.bin.o u-boot-payload.lds FORCE
1675 $(call if_changed,u-boot_payload)
1677 OBJCOPYFLAGS_u-boot-payload.efi := $(OBJCOPYFLAGS_EFI)
1678 u-boot-payload.efi: u-boot-payload FORCE
1679 $(call if_changed,zobjcopy)
1681 u-boot-img.bin: spl/u-boot-spl.bin u-boot.img FORCE
1682 $(call if_changed,cat)
1684 #Add a target to create boot binary having SPL binary in PBI format
1685 #concatenated with u-boot binary. It is need by PowerPC SoC having
1686 #internal SRAM <= 512KB.
1687 MKIMAGEFLAGS_u-boot-spl.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1688 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage \
1689 -A $(ARCH) -a $(CONFIG_SPL_TEXT_BASE)
1691 spl/u-boot-spl.pbl: spl/u-boot-spl.bin FORCE
1692 $(call if_changed,mkimage)
1695 UBOOT_BINLOAD := u-boot.img
1697 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1698 UBOOT_BINLOAD := u-boot-with-dtb.bin
1700 UBOOT_BINLOAD := u-boot.bin
1704 OBJCOPYFLAGS_u-boot-with-spl-pbl.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
1707 u-boot-with-spl-pbl.bin: spl/u-boot-spl.pbl $(UBOOT_BINLOAD) FORCE
1708 $(call if_changed,pad_cat)
1710 # PPC4xx needs the SPL at the end of the image, since the reset vector
1711 # is located at 0xfffffffc. So we can't use the "u-boot-img.bin" target
1712 # and need to introduce a new build target with the full blown U-Boot
1713 # at the start padded up to the start of the SPL image. And then concat
1714 # the SPL image to the end.
1716 OBJCOPYFLAGS_u-boot-img-spl-at-end.bin := -I binary -O binary \
1717 --pad-to=$(CONFIG_UBOOT_PAD_TO) --gap-fill=0xff
1718 u-boot-img-spl-at-end.bin: u-boot.img spl/u-boot-spl.bin FORCE
1719 $(call if_changed,pad_cat)
1721 quiet_cmd_u-boot-elf ?= LD $@
1722 cmd_u-boot-elf ?= $(LD) u-boot-elf.o -o $@ \
1723 $(if $(CONFIG_SYS_BIG_ENDIAN),-EB,-EL) \
1724 -T u-boot-elf.lds --defsym=$(CONFIG_PLATFORM_ELFENTRY)=$(CONFIG_SYS_TEXT_BASE) \
1725 -Ttext=$(CONFIG_SYS_TEXT_BASE)
1726 u-boot.elf: u-boot.bin u-boot-elf.lds
1727 $(Q)$(OBJCOPY) -I binary $(PLATFORM_ELFFLAGS) $< u-boot-elf.o
1728 $(call if_changed,u-boot-elf)
1730 u-boot-elf.lds: arch/u-boot-elf.lds prepare FORCE
1731 $(call if_changed_dep,cpp_lds)
1733 # MediaTek's ARM-based u-boot needs a header to contains its load address
1734 # which is parsed by the BootROM.
1735 # If the SPL build is enabled, the header will be added to the spl binary,
1736 # and the spl binary and the u-boot.img will be combined into one file.
1737 # Otherwise the header will be added to the u-boot.bin directly.
1739 ifeq ($(CONFIG_SPL),y)
1740 spl/u-boot-spl-mtk.bin: spl/u-boot-spl
1742 u-boot-mtk.bin: u-boot-with-spl.bin
1743 $(call if_changed,copy)
1745 MKIMAGEFLAGS_u-boot-mtk.bin = -T mtk_image \
1746 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1747 -n "$(patsubst "%",%,$(CONFIG_MTK_BROM_HEADER_INFO))"
1749 u-boot-mtk.bin: u-boot.bin FORCE
1750 $(call if_changed,mkimage)
1753 quiet_cmd_endian_swap = SWAP $@
1754 cmd_endian_swap = $(srctree)/tools/endian-swap.py $< $@
1756 u-boot-swap.bin: u-boot.bin FORCE
1757 $(call if_changed,endian_swap)
1759 ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(ARCH)/Makefile.postlink)
1761 # Generate linker list symbols references to force compiler to not optimize
1762 # them away when compiling with LTO
1764 u-boot-keep-syms-lto := keep-syms-lto.o
1765 u-boot-keep-syms-lto_c := $(patsubst %.o,%.c,$(u-boot-keep-syms-lto))
1767 quiet_cmd_keep_syms_lto = KSL $@
1768 cmd_keep_syms_lto = \
1769 $(srctree)/scripts/gen_ll_addressable_symbols.sh $(NM) $^ > $@
1771 quiet_cmd_keep_syms_lto_cc = KSLCC $@
1772 cmd_keep_syms_lto_cc = \
1773 $(CC) $(filter-out $(LTO_CFLAGS),$(c_flags)) -c -o $@ $<
1775 $(u-boot-keep-syms-lto_c): $(u-boot-main)
1776 $(call if_changed,keep_syms_lto)
1777 $(u-boot-keep-syms-lto): $(u-boot-keep-syms-lto_c)
1778 $(call if_changed,keep_syms_lto_cc)
1780 u-boot-keep-syms-lto :=
1783 # Rule to link u-boot
1784 # May be overridden by arch/$(ARCH)/config.mk
1786 quiet_cmd_u-boot__ ?= LTO $@
1788 $(CC) -nostdlib -nostartfiles \
1789 $(LTO_FINAL_LDFLAGS) $(c_flags) \
1790 $(KBUILD_LDFLAGS:%=-Wl,%) $(LDFLAGS_u-boot:%=-Wl,%) -o $@ \
1791 -T u-boot.lds $(u-boot-init) \
1792 -Wl,--whole-archive \
1794 $(u-boot-keep-syms-lto) \
1796 -Wl,--no-whole-archive \
1797 -Wl,-Map,u-boot.map; \
1798 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1800 quiet_cmd_u-boot__ ?= LD $@
1801 cmd_u-boot__ ?= $(LD) $(KBUILD_LDFLAGS) $(LDFLAGS_u-boot) -o $@ \
1802 -T u-boot.lds $(u-boot-init) \
1805 --no-whole-archive \
1806 $(PLATFORM_LIBS) -Map u-boot.map; \
1807 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1810 quiet_cmd_smap = GEN common/system_map.o
1812 smap=`$(call SYSTEM_MAP,u-boot) | \
1813 awk '$$2 ~ /[tTwW]/ {printf $$1 $$3 "\\\\000"}'` ; \
1814 $(CC) $(c_flags) -DSYSTEM_MAP="\"$${smap}\"" \
1815 -c $(srctree)/common/system_map.c -o common/system_map.o
1817 u-boot: $(u-boot-init) $(u-boot-main) $(u-boot-keep-syms-lto) u-boot.lds FORCE
1818 +$(call if_changed,u-boot__)
1819 ifeq ($(CONFIG_KALLSYMS),y)
1821 $(call cmd,u-boot__) common/system_map.o
1824 ifeq ($(CONFIG_RISCV),y)
1825 @tools/prelink-riscv $@ 0
1828 quiet_cmd_sym ?= SYM $@
1829 cmd_sym ?= $(OBJDUMP) -t $< > $@
1830 u-boot.sym: u-boot FORCE
1831 $(call if_changed,sym)
1833 # Environment processing
1834 # ---------------------------------------------------------------------------
1836 # Directory where we expect the .env file, if it exists
1837 ENV_DIR := $(srctree)/board/$(BOARDDIR)
1839 # Basename of .env file, stripping quotes
1840 ENV_SOURCE_FILE := $(CONFIG_ENV_SOURCE_FILE:"%"=%)
1842 # Filename of .env file
1843 ENV_FILE_CFG := $(ENV_DIR)/$(ENV_SOURCE_FILE).env
1845 # Default filename, if CONFIG_ENV_SOURCE_FILE is empty
1846 ENV_FILE_BOARD := $(ENV_DIR)/$(CONFIG_SYS_BOARD:"%"=%).env
1848 # Select between the CONFIG_ENV_SOURCE_FILE and the default one
1849 ENV_FILE := $(if $(ENV_SOURCE_FILE),$(ENV_FILE_CFG),$(wildcard $(ENV_FILE_BOARD)))
1851 # Run the environment text file through the preprocessor, but only if it is
1852 # non-empty, to save time and possible build errors if something is wonky with
1854 # If there is no ENV_FILE, produce an empty output file, to prevent a previous
1855 # build's file being used in the case of in-tree builds.
1856 quiet_cmd_gen_envp = ENVP $@
1858 if [ -s "$(ENV_FILE)" ]; then \
1859 $(CPP) -P $(CFLAGS) -x assembler-with-cpp -D__ASSEMBLY__ \
1860 -D__UBOOT_CONFIG__ \
1861 -I . -I include -I $(srctree)/include \
1862 -include linux/kconfig.h -include include/config.h \
1863 -I$(srctree)/arch/$(ARCH)/include \
1869 include/generated/env.in: include/generated/env.txt FORCE
1870 $(call cmd,gen_envp)
1872 # Regenerate the environment if it changes
1873 # We use 'wildcard' since the file is not required to exist (at present), in
1874 # which case we don't want this dependency, but instead should create an empty
1876 # This rule is useful since it shows the source file for the environment
1877 quiet_cmd_envc = ENVC $@
1879 if [ -f "$<" ]; then \
1881 elif [ -n "$(ENV_SOURCE_FILE)" ]; then \
1882 echo "Missing file $(ENV_FILE_CFG)"; \
1887 include/generated/env.txt: $(wildcard $(ENV_FILE)) FORCE
1890 # Write out the resulting environment, converted to a C string
1891 quiet_cmd_gen_envt = ENVT $@
1893 awk -f $(srctree)/scripts/env2string.awk $< >$@
1894 $(env_h): include/generated/env.in
1895 $(call cmd,gen_envt)
1897 # ---------------------------------------------------------------------------
1899 # The actual objects are generated when descending,
1900 # make sure no implicit rule kicks in
1901 $(sort $(u-boot-init) $(u-boot-main)): $(u-boot-dirs) ;
1903 # Handle descending into subdirectories listed in $(u-boot-dirs)
1904 # Preset locale variables to speed up the build process. Limit locale
1905 # tweaks to this spot to avoid wrong language settings when running
1906 # make menuconfig etc.
1907 # Error messages still appears in the original language
1909 PHONY += $(u-boot-dirs)
1910 $(u-boot-dirs): prepare scripts
1911 $(Q)$(MAKE) $(build)=$@
1914 # The "tools" are needed early
1915 $(filter-out tools, $(u-boot-dirs)): tools
1916 # The "examples" conditionally depend on U-Boot (say, when USE_PRIVATE_LIBGCC
1917 # is "yes"), so compile examples after U-Boot is compiled.
1918 examples: $(filter-out examples, $(u-boot-dirs))
1920 define filechk_uboot.release
1921 echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
1924 # Store (new) UBOOTRELEASE string in include/config/uboot.release
1925 include/config/uboot.release: include/config/auto.conf FORCE
1926 $(call filechk,uboot.release)
1929 # Things we need to do before we recursively start building the kernel
1930 # or the modules are listed in "prepare".
1931 # A multi level approach is used. prepareN is processed before prepareN-1.
1932 # archprepare is used in arch Makefiles and when processed asm symlink,
1933 # version.h and scripts_basic is processed / created.
1935 # Listed in dependency order
1936 PHONY += prepare archprepare prepare0 prepare1 prepare2 prepare3
1938 # prepare3 is used to check if we are building in a separate output directory,
1940 # 1) Check that make has not been executed in the kernel src $(srctree)
1941 prepare3: include/config/uboot.release
1942 ifneq ($(KBUILD_SRC),)
1943 @$(kecho) ' Using $(srctree) as source for U-Boot'
1944 $(Q)if [ -f $(srctree)/.config -o -d $(srctree)/include/config ]; then \
1945 echo >&2 " $(srctree) is not clean, please run 'make mrproper'"; \
1946 echo >&2 " in the '$(srctree)' directory.";\
1951 # prepare2 creates a makefile if using a separate output directory
1952 prepare2: prepare3 outputmakefile cfg
1954 prepare1: prepare2 $(version_h) $(timestamp_h) $(dt_h) $(env_h) \
1955 include/config/auto.conf
1956 ifeq ($(wildcard $(LDSCRIPT)),)
1957 @echo >&2 " Could not find linker script."
1961 ifeq ($(CONFIG_USE_DEFAULT_ENV_FILE),y)
1962 prepare1: $(defaultenv_h)
1964 envtools: $(defaultenv_h)
1967 archprepare: prepare1 scripts_basic
1969 prepare0: archprepare FORCE
1970 $(Q)$(MAKE) $(build)=.
1972 # All the preparing..
1975 # Generate some files
1976 # ---------------------------------------------------------------------------
1978 # Use sed to remove leading zeros from PATCHLEVEL to avoid using octal numbers
1979 define filechk_version.h
1980 (echo \#define PLAIN_VERSION \"$(UBOOTRELEASE)\"; \
1981 echo \#define U_BOOT_VERSION \"U-Boot \" PLAIN_VERSION; \
1982 echo \#define U_BOOT_VERSION_NUM $(VERSION); \
1983 echo \#define U_BOOT_VERSION_NUM_PATCH $$(echo $(PATCHLEVEL) | \
1984 sed -e "s/^0*//"); \
1985 echo \#define CC_VERSION_STRING \"$$(LC_ALL=C $(CC) --version | head -n 1)\"; \
1986 echo \#define LD_VERSION_STRING \"$$(LC_ALL=C $(LD) --version | head -n 1)\"; )
1989 # The SOURCE_DATE_EPOCH mechanism requires a date that behaves like GNU date.
1990 # The BSD date on the other hand behaves different and would produce errors
1991 # with the misused '-d' switch. Respect that and search a working date with
1992 # well known pre- and suffixes for the GNU variant of date.
1993 define filechk_timestamp.h
1994 (if test -n "$${SOURCE_DATE_EPOCH}"; then \
1995 SOURCE_DATE="@$${SOURCE_DATE_EPOCH}"; \
1997 for date in gdate date.gnu date; do \
1998 $${date} -u -d "$${SOURCE_DATE}" >/dev/null 2>&1 && DATE="$${date}"; \
2000 if test -n "$${DATE}"; then \
2001 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DATE "%b %d %C%y"'; \
2002 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TIME "%T"'; \
2003 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TZ "%z"'; \
2004 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_EPOCH %s'; \
2009 LC_ALL=C date +'#define U_BOOT_DATE "%b %d %C%y"'; \
2010 LC_ALL=C date +'#define U_BOOT_TIME "%T"'; \
2011 LC_ALL=C date +'#define U_BOOT_TZ "%z"'; \
2012 LC_ALL=C date +'#define U_BOOT_EPOCH %s'; \
2016 define filechk_defaultenv.h
2017 ( { grep -v '^#' | grep -v '^$$' || true ; echo '' ; } | \
2019 sed -e 's/\\\x0\s*//g' | \
2024 (if test -n "$${DEVICE_TREE}"; then \
2025 echo \#define DEVICE_TREE \"$(DEVICE_TREE)\"; \
2027 echo \#define DEVICE_TREE CONFIG_DEFAULT_DEVICE_TREE; \
2031 $(version_h): include/config/uboot.release FORCE
2032 $(call filechk,version.h)
2034 $(timestamp_h): $(srctree)/Makefile FORCE
2035 $(call filechk,timestamp.h)
2037 $(dt_h): $(srctree)/Makefile FORCE
2038 $(call filechk,dt.h)
2040 $(defaultenv_h): $(CONFIG_DEFAULT_ENV_FILE:"%"=%) FORCE
2041 $(call filechk,defaultenv.h)
2043 # ---------------------------------------------------------------------------
2046 ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/boot/dts/),)
2047 dtstree := arch/$(SRCARCH)/boot/dts
2052 %.dtb: prepare3 scripts_dtc
2053 $(Q)$(MAKE) $(build)=$(dtstree) $(dtstree)/$@
2055 PHONY += dtbs dtbs_install
2056 dtbs: prepare3 scripts_dtc
2057 $(Q)$(MAKE) $(build)=$(dtstree)
2060 $(Q)$(MAKE) $(dtbinst)=$(dtstree)
2062 ifdef CONFIG_OF_EARLY_FLATTREE
2068 # Check dtc and pylibfdt, if DTC is provided, else build them
2069 PHONY += scripts_dtc
2070 scripts_dtc: scripts_basic
2071 $(Q)if test "$(DTC)" = "$(DTC_INTREE)"; then \
2072 $(MAKE) $(build)=scripts/dtc; \
2074 if ! $(DTC) -v >/dev/null; then \
2075 echo '*** Failed to check dtc version: $(DTC)'; \
2078 if test "$(call dtc-version)" -lt $(DTC_MIN_VERSION); then \
2079 echo '*** Your dtc is too old, please upgrade to dtc $(DTC_MIN_VERSION) or newer'; \
2082 if [ -n "$(CONFIG_PYLIBFDT)" ]; then \
2083 if ! echo "import libfdt" | $(PYTHON3) 2>/dev/null; then \
2084 echo '*** pylibfdt does not seem to be available with $(PYTHON3)'; \
2092 # ---------------------------------------------------------------------------
2093 quiet_cmd_cpp_lds = LDS $@
2094 cmd_cpp_lds = $(CPP) -Wp,-MD,$(depfile) $(cpp_flags) $(LDPPFLAGS) \
2095 -D__ASSEMBLY__ -x assembler-with-cpp -std=c99 -P -o $@ $<
2097 u-boot.lds: $(LDSCRIPT) prepare FORCE
2098 $(call if_changed_dep,cpp_lds)
2100 spl/u-boot-spl.bin: spl/u-boot-spl
2104 spl/u-boot-spl-dtb.bin: spl/u-boot-spl
2107 spl/u-boot-spl-dtb.hex: spl/u-boot-spl
2110 spl/u-boot-spl: tools prepare $(if $(CONFIG_SPL_OF_CONTROL),dts/dt.dtb)
2111 $(Q)$(MAKE) obj=spl -f $(srctree)/scripts/Makefile.spl all
2113 spl/sunxi-spl.bin: spl/u-boot-spl
2116 spl/sunxi-spl-with-ecc.bin: spl/sunxi-spl.bin
2119 spl/u-boot-spl.sfp: spl/u-boot-spl
2122 spl/boot.bin: spl/u-boot-spl
2125 tpl/u-boot-tpl.bin: tpl/u-boot-tpl
2129 tpl/u-boot-tpl: tools prepare $(if $(CONFIG_TPL_OF_CONTROL),dts/dt.dtb)
2130 $(Q)$(MAKE) obj=tpl -f $(srctree)/scripts/Makefile.spl all
2132 vpl/u-boot-vpl.bin: vpl/u-boot-vpl
2136 vpl/u-boot-vpl: tools prepare $(if $(CONFIG_TPL_OF_CONTROL),dts/dt.dtb)
2137 $(Q)$(MAKE) obj=vpl -f $(srctree)/scripts/Makefile.spl all
2139 TAG_SUBDIRS := $(patsubst %,$(srctree)/%,$(u-boot-dirs) include)
2145 ctags -w -o ctags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2146 -name '*.[chS]' -print`
2150 etags -a -o etags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2151 -name '*.[chS]' -print`
2153 $(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) -name '*.[chS]' -print > \
2155 @find $(TAG_SUBDIRS) -name '*.[chS]' -type l -print | \
2156 grep -xvf - cscope.files > cscope.files.no-symlinks; \
2157 mv cscope.files.no-symlinks cscope.files
2162 grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
2165 @$(call SYSTEM_MAP,$<) > $@
2167 #########################################################################
2169 # ARM relocations should all be R_ARM_RELATIVE (32-bit) or
2170 # R_AARCH64_RELATIVE (64-bit).
2171 checkarmreloc: u-boot
2172 @RELOC="`$(CROSS_COMPILE)readelf -r -W $< | cut -d ' ' -f 4 | \
2173 grep R_A | sort -u`"; \
2174 if test "$$RELOC" != "R_ARM_RELATIVE" -a \
2175 "$$RELOC" != "R_AARCH64_RELATIVE"; then \
2176 echo "$< contains unexpected relocations: $$RELOC"; \
2180 tools/version.h: include/version.h
2181 $(Q)mkdir -p $(dir $@)
2182 $(call if_changed,copy)
2184 envtools: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2185 $(Q)$(MAKE) $(build)=tools/env
2187 tools-only: export TOOLS_ONLY=y
2188 tools-only: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2189 $(Q)$(MAKE) $(build)=tools
2191 tools-all: export HOST_TOOLS_ALL=y
2192 tools-all: envtools tools ;
2194 cross_tools: export CROSS_BUILD_TOOLS=y
2195 cross_tools: tools ;
2199 git log --no-merges U-Boot-1_1_5.. | \
2200 unexpand -a | sed -e 's/\s\s*$$//' > $@
2202 #########################################################################
2205 # Cleaning is done on three levels.
2206 # make clean Delete most generated files
2207 # Leave enough to build external modules
2208 # make mrproper Delete the current configuration, and all generated files
2209 # make distclean Remove editor backup files, patch leftover files and the like
2211 # Directories & files removed with 'make clean'
2212 CLEAN_DIRS += $(MODVERDIR) \
2213 $(foreach d, spl tpl, $(patsubst %,$d/%, \
2214 $(filter-out include, $(shell ls -1 $d 2>/dev/null))))
2216 CLEAN_FILES += include/bmp_logo.h include/bmp_logo_data.h \
2217 include/generated/env.* drivers/video/u_boot_logo.S \
2218 tools/version.h u-boot* MLO* SPL System.map fit-dtb.blob* \
2219 u-boot-ivt.img.log u-boot-dtb.imx.log SPL.log u-boot.imx.log \
2220 lpc32xx-* bl31.c bl31.elf bl31_*.bin image.map tispl.bin* \
2221 idbloader.img flash.bin flash.log defconfig keep-syms-lto.c \
2222 mkimage-out.spl.mkimage mkimage.spl.mkimage imx-boot.map \
2223 itb.fit.fit itb.fit.itb itb.map spl.map
2225 # Directories & files removed with 'make mrproper'
2226 MRPROPER_DIRS += include/config include/generated spl tpl \
2227 .tmp_objdiff doc/output include/asm
2229 # Remove include/asm symlink created by U-Boot before v2014.01
2230 MRPROPER_FILES += .config .config.old include/autoconf.mk* include/config.h \
2231 ctags etags tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
2232 drivers/video/fonts/*.S include/asm
2234 # clean - Delete most, but leave enough to build external modules
2236 clean: rm-dirs := $(CLEAN_DIRS)
2237 clean: rm-files := $(CLEAN_FILES)
2239 clean-dirs := $(foreach f,$(u-boot-alldirs),$(if $(wildcard $(srctree)/$f/Makefile),$f))
2241 clean-dirs := $(addprefix _clean_, $(clean-dirs))
2243 PHONY += $(clean-dirs) clean archclean
2245 $(Q)$(MAKE) $(clean)=$(patsubst _clean_%,%,$@)
2247 clean: $(clean-dirs)
2250 @find $(if $(KBUILD_EXTMOD), $(KBUILD_EXTMOD), .) $(RCS_FIND_IGNORE) \
2251 \( -name '*.[oas]' -o -name '*.ko' -o -name '.*.cmd' \
2252 -o -name '*.ko.*' -o -name '*.su' -o -name '*.pyc' \
2253 -o -name '.*.d' -o -name '.*.tmp' -o -name '*.mod.c' \
2254 -o -name '*.lex.c' -o -name '*.tab.[ch]' \
2255 -o -name '*.asn1.[ch]' \
2256 -o -name '*.symtypes' -o -name 'modules.order' \
2257 -o -name modules.builtin -o -name '.tmp_*.o.*' \
2258 -o -name 'dsdt_generated.aml' -o -name 'dsdt_generated.asl.tmp' \
2259 -o -name 'dsdt_generated.c' \
2260 -o -name '*.efi' -o -name '*.gcno' -o -name '*.so' \) \
2261 -type f -print | xargs rm -f
2263 # mrproper - Delete all generated files, including .config
2265 mrproper: rm-dirs := $(wildcard $(MRPROPER_DIRS))
2266 mrproper: rm-files := $(wildcard $(MRPROPER_FILES))
2267 mrproper-dirs := $(addprefix _mrproper_,scripts)
2269 PHONY += $(mrproper-dirs) mrproper archmrproper
2271 $(Q)$(MAKE) $(clean)=$(patsubst _mrproper_%,%,$@)
2273 mrproper: clean $(mrproper-dirs)
2276 @rm -f arch/*/include/asm/arch
2283 @find $(srctree) $(RCS_FIND_IGNORE) \
2284 \( -name '*.orig' -o -name '*.rej' -o -name '*~' \
2285 -o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
2286 -o -name '.*.rej' -o -name '*%' -o -name 'core' \
2287 -o -name '*.pyc' \) \
2288 -type f -print | xargs rm -f
2289 @rm -f boards.cfg CHANGELOG
2291 # See doc/develop/python_cq.rst
2292 PHONY += pylint pylint_err
2293 PYLINT_BASE := scripts/pylint.base
2294 PYLINT_CUR := pylint.cur
2295 PYLINT_DIFF := pylint.diff
2297 $(Q)echo "Running pylint on all files (summary in $(PYLINT_CUR); output in pylint.out/)"
2298 $(Q)mkdir -p pylint.out
2299 $(Q)rm -f pylint.out/out*
2300 $(Q)find tools test -name "*.py" \
2301 | xargs -n1 -P$(shell nproc 2>/dev/null || echo 1) \
2302 sh -c 'pylint --reports=y --exit-zero -f parseable --ignore-imports=yes $$@ > pylint.out/$$(echo $$@ | tr / _ | sed s/.py//)' _
2303 $(Q)rm -f $(PYLINT_CUR)
2304 $(Q)( cd pylint.out; for f in *; do \
2305 sed -ne "s/Your code has been rated at \([-0-9.]*\).*/$$f \1/p" $$f; \
2306 done ) | sort > $(PYLINT_CUR)
2307 $(Q)base=$$(mktemp) cur=$$(mktemp); cut -d' ' -f1 $(PYLINT_BASE) >$$base; \
2308 cut -d' ' -f1 $(PYLINT_CUR) >$$cur; \
2309 comm -3 $$base $$cur > $(PYLINT_DIFF); \
2310 if [ -s $(PYLINT_DIFF) ]; then \
2311 echo "Files have been added/removed. Try:\n\tcp $(PYLINT_CUR) $(PYLINT_BASE)"; \
2313 echo "Added files:"; \
2314 comm -13 $$base $$cur; \
2316 echo "Removed files:"; \
2317 comm -23 $$base $$cur; \
2320 rm $$base $$cur $(PYLINT_DIFF); \
2322 $(Q)bad=false; while read base_file base_val <&3 && read cur_file cur_val <&4; do \
2323 if awk "BEGIN {exit !($$cur_val < $$base_val)}"; then \
2324 echo "$$base_file: Score was $$base_val, now $$cur_val"; \
2326 done 3<$(PYLINT_BASE) 4<$(PYLINT_CUR); \
2328 echo "Some files have regressed, please fix"; \
2331 echo "No pylint regressions"; \
2334 # Check for errors only
2336 $(Q)pylint -E -j 0 --ignore-imports=yes \
2337 $(shell find tools test -name "*.py")
2340 F=`basename $(srctree)` ; cd .. ; \
2341 gtar --force-local -zcvf `LC_ALL=C date "+$$F-%Y-%m-%d-%T.tar.gz"` $$F
2344 @echo 'Cleaning targets:'
2345 @echo ' clean - Remove most generated files but keep the config'
2346 @echo ' mrproper - Remove all generated files + config + various backup files'
2347 @echo ' distclean - mrproper + remove editor backup and patch files'
2349 @echo 'Configuration targets:'
2350 @$(MAKE) -f $(srctree)/scripts/kconfig/Makefile help
2352 @echo 'Test targets:'
2354 @echo ' check - Run all automated tests that use sandbox'
2355 @echo ' qcheck - Run quick automated tests that use sandbox'
2356 @echo ' tcheck - Run quick automated tests on tools'
2357 @echo ' pylint - Run pylint on all Python files'
2359 @echo 'Other generic targets:'
2360 @echo ' all - Build all necessary images depending on configuration'
2361 @echo ' tests - Build U-Boot for sandbox and run tests'
2362 @echo '* u-boot - Build the bare u-boot'
2363 @echo ' dir/ - Build all files in dir and below'
2364 @echo ' dir/file.[oisS] - Build specified target only'
2365 @echo ' dir/file.lst - Build specified mixed source/assembly target only'
2366 @echo ' (requires a recent binutils and recent build (System.map))'
2367 @echo ' tags/ctags - Generate ctags file for editors'
2368 @echo ' etags - Generate etags file for editors'
2369 @echo ' cscope - Generate cscope index'
2370 @echo ' ubootrelease - Output the release version string (use with make -s)'
2371 @echo ' ubootversion - Output the version stored in Makefile (use with make -s)'
2372 @echo " cfg - Don't build, just create the .cfg files"
2373 @echo " envtools - Build only the target-side environment tools"
2375 @echo 'Static analysers'
2376 @echo ' checkstack - Generate a list of stack hogs'
2377 @echo ' coccicheck - Execute static code analysis with Coccinelle'
2379 @echo 'Documentation targets:'
2380 @$(MAKE) -f $(srctree)/doc/Makefile dochelp
2382 @echo ' make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
2383 @echo ' make V=2 [targets] 2 => give reason for rebuild of target'
2384 @echo ' make O=dir [targets] Locate all output files in "dir", including .config'
2385 @echo ' make C=1 [targets] Check all c source with $$CHECK (sparse by default)'
2386 @echo ' make C=2 [targets] Force check of all c source with $$CHECK'
2387 @echo ' make RECORDMCOUNT_WARN=1 [targets] Warn about ignored mcount sections'
2388 @echo ' make W=n [targets] Enable extra gcc checks, n=1,2,3 where'
2389 @echo ' 1: warnings which may be relevant and do not occur too often'
2390 @echo ' 2: warnings which occur quite often but may still be relevant'
2391 @echo ' 3: more obscure warnings, can most likely be ignored'
2392 @echo ' Multiple levels can be combined with W=12 or W=123'
2394 @echo 'Execute "make" or "make all" to build all targets marked with [*] '
2395 @echo 'For further info see the ./README file'
2401 $(srctree)/test/run quick
2404 $(srctree)/test/run tools
2406 # Documentation targets
2407 # ---------------------------------------------------------------------------
2408 DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
2409 linkcheckdocs dochelp refcheckdocs
2410 PHONY += $(DOC_TARGETS)
2411 $(DOC_TARGETS): scripts_basic FORCE
2412 $(Q)$(MAKE) $(build)=doc $@
2414 PHONY += checkstack ubootrelease ubootversion
2417 $(OBJDUMP) -d u-boot $$(find . -name u-boot-spl) | \
2418 $(PERL) $(src)/scripts/checkstack.pl $(ARCH)
2421 @echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
2424 @echo $(UBOOTVERSION)
2427 # ---------------------------------------------------------------------------
2428 # Single targets are compatible with:
2429 # - build with mixed source and output
2430 # - build with separate output dir 'make O=...'
2431 # - external modules
2433 # target-dir => where to store outputfile
2434 # build-dir => directory in kernel source tree to use
2436 ifeq ($(KBUILD_EXTMOD),)
2437 build-dir = $(patsubst %/,%,$(dir $@))
2438 target-dir = $(dir $@)
2440 zap-slash=$(filter-out .,$(patsubst %/,%,$(dir $@)))
2441 build-dir = $(KBUILD_EXTMOD)$(if $(zap-slash),/$(zap-slash))
2442 target-dir = $(if $(KBUILD_EXTMOD),$(dir $<),$(dir $@))
2445 %.s: %.c prepare scripts FORCE
2446 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2447 %.i: %.c prepare scripts FORCE
2448 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2449 %.o: %.c prepare scripts FORCE
2450 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2451 %.lst: %.c prepare scripts FORCE
2452 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2453 %.s: %.S prepare scripts FORCE
2454 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2455 %.o: %.S prepare scripts FORCE
2456 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2457 %.symtypes: %.c prepare scripts FORCE
2458 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2461 /: prepare scripts FORCE
2463 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2464 $(build)=$(build-dir)
2465 %/: prepare scripts FORCE
2467 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2468 $(build)=$(build-dir)
2469 %.ko: prepare scripts FORCE
2471 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2472 $(build)=$(build-dir) $(@:.ko=.o)
2473 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.modpost
2475 quiet_cmd_genenv = GENENV $@
2476 cmd_genenv = $(OBJCOPY) --dump-section .rodata.default_environment=$@ env/common.o; \
2477 sed --in-place -e 's/\x00/\x0A/g' $@; sed --in-place -e '/^\s*$$/d' $@; \
2478 sort --field-separator== -k1,1 --stable $@ -o $@
2480 u-boot-initial-env: u-boot.bin
2481 $(call if_changed,genenv)
2483 # Consistency checks
2484 # ---------------------------------------------------------------------------
2489 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@
2491 # FIXME Should go into a make.lib or something
2492 # ===========================================================================
2494 quiet_cmd_rmdirs = $(if $(wildcard $(rm-dirs)),CLEAN $(wildcard $(rm-dirs)))
2495 cmd_rmdirs = rm -rf $(rm-dirs)
2497 quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),CLEAN $(wildcard $(rm-files)))
2498 cmd_rmfiles = rm -f $(rm-files)
2500 # read all saved command lines
2502 cmd_files := $(wildcard .*.cmd)
2504 ifneq ($(cmd_files),)
2505 $(cmd_files): ; # Do not try to update included dependency files
2506 include $(cmd_files)
2509 endif #ifeq ($(config-targets),1)
2510 endif #ifeq ($(mixed-targets),1)
2511 endif # skip-makefile
2516 # Declare the contents of the PHONY variable as phony. We keep that
2517 # information in a variable so we can use it in if_changed and friends.